////////////////////////////////////////////////////////////////////////////////
//
// Fracter - A simple Mandelbrot Set viewer.
//
// Copyright (C) 2010 Sarah Eris Horsley Caffee
//
// This file is part of Fracter.
//
// Fracter is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// main.cpp
//
////////////////////////////////////////////////////////////////////////////////

#include <exception>
#include <iostream>

#include "App.h"

////////////////////////////////////////////////////////////////////////////////

int main (int argc, char* argv[])
   {
   int retval = 0;

   std::cout << "Copyright (C) 2010 Sarah Eris Horsley Caffee" << std::endl
	     << "This program comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions. It is licensed under the GNU GPL v3. For details see the COPYING file that you should have received along with this program, or see http://www.gnu.org/licenses/gpl-3.0.html" << std::endl << std::endl;;

   try
      {
      App the_app;
      retval = the_app.run();
      }
   catch (const std::exception & error)
      {
      std::string e = "An unanticipated error has occurred.  Please contacct the developers and report the following information:\nCaught exception: ";
      e += error.what();
      std::cerr << e << std::endl;
      retval = 1;
      }

   return retval;;
   }
